<html lang="en">
<head>
<title>Generic Tag Lists - Speedbar: File/Tag summarizing utility</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Speedbar: File/Tag summarizing utility">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Creating-a-display.html#Creating-a-display" title="Creating a display">
<link rel="prev" href="Creating-Buttons.html#Creating-Buttons" title="Creating Buttons">
<link rel="next" href="Expand-Buttons.html#Expand-Buttons" title="Expand Buttons">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Generic-Tag-Lists"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Expand-Buttons.html#Expand-Buttons">Expand Buttons</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Creating-Buttons.html#Creating-Buttons">Creating Buttons</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Creating-a-display.html#Creating-a-display">Creating a display</a>
<hr>
</div>

<h4 class="subsection">7.4.2 Generic Tag Lists</h4>

<p>For data stored in a hierarchical list, it is likely possible to
have the entire data structure inserted with the speedbar generic list
methods.

   <p>These insertion functions assume that the data represents 'tags', or
data extracted from inside a file, and they are marked with tag
markers.

   <p>Tags stored in this format can then be manipulated by the tag
hierarchy methods described earlier in this manual.

<div class="defun">
&mdash; Function: <b>speedbar-insert-generic-list</b><var> level list expand-fun find-fun<a name="index-speedbar_002dinsert_002dgeneric_002dlist-86"></a></var><br>
<blockquote>
<p>At <var>level</var>, (the current indentation level desired) insert a generic
multi-level alist <var>list</var>.  Associations with lists get `<samp><span class="samp">{+}</span></samp>'
tags (to expand into more nodes) and those with positions or other data
just get a `<samp><span class="samp">&gt;</span></samp>' as the indicator.  `<samp><span class="samp">{+}</span></samp>' buttons will have the
function <var>expand-fun</var> and the token is the <code>cdr</code> list.  The
token name will have the function <var>find-fun</var> and not token.

        <p>Each element of the list can have one of these forms:

          <dl>
<dt><code>(</code><var>name</var><code> . marker-or-number)</code><dd>One tag at this level. 
<br><dt><code>(</code><var>name</var><code> (</code><var>name</var><code> . marker-or-number) (</code><var>name</var><code> . marker-or-number) ... )</code><dd>One group of tags. 
<br><dt><code>(</code><var>name</var><code> marker-or-number (</code><var>name</var><code> . marker-or-number) ... )</code><dd>One Group of tags where the group has a starting position. 
</dl>

        <p>When you use <code>speedbar-insert-generic-list</code>, there are some
variables you can set buffer-locally to change the behavior.  The most
obvious is <code>speedbar-tag-hierarchy-method</code>. 
See <a href="Tag-Hierarchy-Methods.html#Tag-Hierarchy-Methods">Tag Hierarchy Methods</a>.

     <div class="defun">
&mdash; Variable: <b>speedbar-generic-list-group-expand-button-type</b><var><a name="index-speedbar_002dgeneric_002dlist_002dgroup_002dexpand_002dbutton_002dtype-87"></a></var><br>
<blockquote><p>This is the button type used for groups of tags, whether expanded
or added in via a hierarchy method.  Two good values are
<code>'curly</code> and <code>'expandtag</code>.  Curly is the default button, and
<code>'expandtag</code> is useful if the groups also has a position. 
</p></blockquote></div>

     <div class="defun">
&mdash; Variable: <b>speedbar-generic-list-tag-button-type</b><var><a name="index-speedbar_002dgeneric_002dlist_002dtag_002dbutton_002dtype-88"></a></var><br>
<blockquote><p>This is the button type used for a single tag. 
Two good values are <code>nil</code> and <code>'statictag</code>. 
<code>nil</code> is the default, and <code>'statictag</code> has the same width as
<code>'expandtag</code>. 
</p></blockquote></div>

        </blockquote></div>

   </body></html>

